diff -Naur openssl-1.0.0q.orig/crypto/bf/bftest.c openssl-1.0.0q/crypto/bf/bftest.c
--- openssl-1.0.0q.orig/crypto/bf/bftest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bftest.c	2017-04-25 16:23:40.034527849 +0200
@@ -59,9 +59,11 @@
 /* This has been a quickly hacked 'ideatest.c'.  When I add tests for other
  * RC2 modes, more of the code will be uncommented. */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/opensslconf.h> /* To see if OPENSSL_NO_BF is defined */
 
 #include "../e_os.h"
@@ -362,21 +364,21 @@
 	BF_LONG len;
 
 #ifdef CHARSET_EBCDIC
-	ebcdic2ascii(cbc_data, cbc_data, strlen(cbc_data));
+	ebcdic2ascii(cbc_data, cbc_data, op_strlen(cbc_data));
 #endif
 
 	printf("testing blowfish in raw ecb mode\n");
 	for (n=0; n<2; n++)
 		{
 #ifdef CHARSET_EBCDIC
-		ebcdic2ascii(bf_key[n], bf_key[n], strlen(bf_key[n]));
+		ebcdic2ascii(bf_key[n], bf_key[n], op_strlen(bf_key[n]));
 #endif
 		BF_set_key(&key,strlen(bf_key[n]),(unsigned char *)bf_key[n]);
 
 		data[0]=bf_plain[n][0];
 		data[1]=bf_plain[n][1];
 		BF_encrypt(data,&key);
-		if (memcmp(&(bf_cipher[n][0]),&(data[0]),8) != 0)
+		if (op_memcmp(&(bf_cipher[n][0]),&(data[0]),8) != 0)
 			{
 			printf("BF_encrypt error encrypting\n");
 			printf("got     :");
@@ -391,7 +393,7 @@
 			}
 
 		BF_decrypt(&(data[0]),&key);
-		if (memcmp(&(bf_plain[n][0]),&(data[0]),8) != 0)
+		if (op_memcmp(&(bf_plain[n][0]),&(data[0]),8) != 0)
 			{
 			printf("BF_encrypt error decrypting\n");
 			printf("got     :");
@@ -413,7 +415,7 @@
 		BF_set_key(&key,8,ecb_data[n]);
 
 		BF_ecb_encrypt(&(plain_data[n][0]),out,&key,BF_ENCRYPT);
-		if (memcmp(&(cipher_data[n][0]),out,8) != 0)
+		if (op_memcmp(&(cipher_data[n][0]),out,8) != 0)
 			{
 			printf("BF_ecb_encrypt blowfish error encrypting\n");
 			printf("got     :");
@@ -428,7 +430,7 @@
 			}
 
 		BF_ecb_encrypt(out,out,&key,BF_DECRYPT);
-		if (memcmp(&(plain_data[n][0]),out,8) != 0)
+		if (op_memcmp(&(plain_data[n][0]),out,8) != 0)
 			{
 			printf("BF_ecb_encrypt error decrypting\n");
 			printf("got     :");
@@ -449,7 +451,7 @@
 		BF_set_key(&key,n,key_test);
 		BF_ecb_encrypt(key_data,out,&key,BF_ENCRYPT);
 		/* mips-sgi-irix6.5-gcc  vv  -mabi=64 bug workaround */
-		if (memcmp(out,&(key_out[i=n-1][0]),8) != 0)
+		if (op_memcmp(out,&(key_out[i=n-1][0]),8) != 0)
 			{
 			printf("blowfish setkey error\n");
 			err=1;
@@ -457,24 +459,24 @@
 		}
 
 	printf("testing blowfish in cbc mode\n");
-	len=strlen(cbc_data)+1;
+	len=op_strlen(cbc_data)+1;
 
 	BF_set_key(&key,16,cbc_key);
-	memset(cbc_in,0,sizeof cbc_in);
-	memset(cbc_out,0,sizeof cbc_out);
-	memcpy(iv,cbc_iv,sizeof iv);
+	op_memset(cbc_in,0,sizeof cbc_in);
+	op_memset(cbc_out,0,sizeof cbc_out);
+	op_memcpy(iv,cbc_iv,sizeof iv);
 	BF_cbc_encrypt((unsigned char *)cbc_data,cbc_out,len,
 		&key,iv,BF_ENCRYPT);
-	if (memcmp(cbc_out,cbc_ok,32) != 0)
+	if (op_memcmp(cbc_out,cbc_ok,32) != 0)
 		{
 		err=1;
 		printf("BF_cbc_encrypt encrypt error\n");
 		for (i=0; i<32; i++) printf("0x%02X,",cbc_out[i]);
 		}
-	memcpy(iv,cbc_iv,8);
+	op_memcpy(iv,cbc_iv,8);
 	BF_cbc_encrypt(cbc_out,cbc_in,len,
 		&key,iv,BF_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen(cbc_data)+1) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen(cbc_data)+1) != 0)
 		{
 		printf("BF_cbc_encrypt decrypt error\n");
 		err=1;
@@ -483,27 +485,27 @@
 	printf("testing blowfish in cfb64 mode\n");
 
 	BF_set_key(&key,16,cbc_key);
-	memset(cbc_in,0,40);
-	memset(cbc_out,0,40);
-	memcpy(iv,cbc_iv,8);
+	op_memset(cbc_in,0,40);
+	op_memset(cbc_out,0,40);
+	op_memcpy(iv,cbc_iv,8);
 	n=0;
 	BF_cfb64_encrypt((unsigned char *)cbc_data,cbc_out,(long)13,
 		&key,iv,&n,BF_ENCRYPT);
 	BF_cfb64_encrypt((unsigned char *)&(cbc_data[13]),&(cbc_out[13]),len-13,
 		&key,iv,&n,BF_ENCRYPT);
-	if (memcmp(cbc_out,cfb64_ok,(int)len) != 0)
+	if (op_memcmp(cbc_out,cfb64_ok,(int)len) != 0)
 		{
 		err=1;
 		printf("BF_cfb64_encrypt encrypt error\n");
 		for (i=0; i<(int)len; i++) printf("0x%02X,",cbc_out[i]);
 		}
 	n=0;
-	memcpy(iv,cbc_iv,8);
+	op_memcpy(iv,cbc_iv,8);
 	BF_cfb64_encrypt(cbc_out,cbc_in,17,
 		&key,iv,&n,BF_DECRYPT);
 	BF_cfb64_encrypt(&(cbc_out[17]),&(cbc_in[17]),len-17,
 		&key,iv,&n,BF_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,(int)len) != 0)
+	if (op_memcmp(cbc_in,cbc_data,(int)len) != 0)
 		{
 		printf("BF_cfb64_encrypt decrypt error\n");
 		err=1;
@@ -512,24 +514,24 @@
 	printf("testing blowfish in ofb64\n");
 
 	BF_set_key(&key,16,cbc_key);
-	memset(cbc_in,0,40);
-	memset(cbc_out,0,40);
-	memcpy(iv,cbc_iv,8);
+	op_memset(cbc_in,0,40);
+	op_memset(cbc_out,0,40);
+	op_memcpy(iv,cbc_iv,8);
 	n=0;
 	BF_ofb64_encrypt((unsigned char *)cbc_data,cbc_out,(long)13,&key,iv,&n);
 	BF_ofb64_encrypt((unsigned char *)&(cbc_data[13]),
 		&(cbc_out[13]),len-13,&key,iv,&n);
-	if (memcmp(cbc_out,ofb64_ok,(int)len) != 0)
+	if (op_memcmp(cbc_out,ofb64_ok,(int)len) != 0)
 		{
 		err=1;
 		printf("BF_ofb64_encrypt encrypt error\n");
 		for (i=0; i<(int)len; i++) printf("0x%02X,",cbc_out[i]);
 		}
 	n=0;
-	memcpy(iv,cbc_iv,8);
+	op_memcpy(iv,cbc_iv,8);
 	BF_ofb64_encrypt(cbc_out,cbc_in,17,&key,iv,&n);
 	BF_ofb64_encrypt(&(cbc_out[17]),&(cbc_in[17]),len-17,&key,iv,&n);
-	if (memcmp(cbc_in,cbc_data,(int)len) != 0)
+	if (op_memcmp(cbc_in,cbc_data,(int)len) != 0)
 		{
 		printf("BF_ofb64_encrypt decrypt error\n");
 		err=1;
diff -Naur openssl-1.0.0q.orig/crypto/bf/opera_bf_ecb.cpp openssl-1.0.0q/crypto/bf/opera_bf_ecb.cpp
--- openssl-1.0.0q.orig/crypto/bf/opera_bf_ecb.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/opera_bf_ecb.cpp	2017-04-25 16:23:40.036526706 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "bf_ecb.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/bf/opera_bf_ofb64.cpp openssl-1.0.0q/crypto/bf/opera_bf_ofb64.cpp
--- openssl-1.0.0q.orig/crypto/bf/opera_bf_ofb64.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/opera_bf_ofb64.cpp	2017-04-25 16:23:40.037526833 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "bf_ofb64.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/bio/.gitignore openssl-1.0.0q/crypto/bio/.gitignore
--- openssl-1.0.0q.orig/crypto/bio/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/.gitignore	2017-04-25 16:23:40.038526681 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/bio/b_dump.c openssl-1.0.0q/crypto/bio/b_dump.c
--- openssl-1.0.0q.orig/crypto/bio/b_dump.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/b_dump.c	2017-04-25 16:23:40.038526681 +0200
@@ -60,19 +60,24 @@
  * Stolen from tjh's ssl/ssl_trc.c stuff.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bio_lcl.h"
 
 #define TRUNCATE
 #define DUMP_WIDTH	16
 #define DUMP_WIDTH_LESS_INDENT(i) (DUMP_WIDTH-((i-(i>6?6:i)+3)/4))
 
+#ifndef OPERA_SMALL_VERSION
+
 int BIO_dump_cb(int (*cb)(const void *data, size_t len, void *u),
 	void *u, const char *s, int len)
 	{
 	return BIO_dump_indent_cb(cb, u, s, len, 0);
 	}
+#endif
 
 int BIO_dump_indent_cb(int (*cb)(const void *data, size_t len, void *u),
 	void *u, const char *s, int len, int indent)
@@ -95,7 +100,7 @@
 	if (indent)
 		{
 		if (indent > 128) indent=128;
-		memset(str,' ',indent);
+		op_memset(str,' ',indent);
 		}
 	str[indent]='\0';
 
@@ -157,6 +162,7 @@
 	return(ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_FP_API
 static int write_fp(const void *data, size_t len, void *fp)
 	{
@@ -171,17 +177,22 @@
 	return BIO_dump_indent_cb(write_fp, fp, s, len, indent);
 	}
 #endif
+#endif // OPERA_SMALL
 
+#ifndef OPERA_SMALL_VERSION
 static int write_bio(const void *data, size_t len, void *bp)
 	{
 	return BIO_write((BIO *)bp, (const char *)data, len);
 	}
+
 int BIO_dump(BIO *bp, const char *s, int len)
 	{
 	return BIO_dump_cb(write_bio, bp, s, len);
 	}
+
 int BIO_dump_indent(BIO *bp, const char *s, int len, int indent)
 	{
 	return BIO_dump_indent_cb(write_bio, bp, s, len, indent);
 	}
+#endif // OPERA_SMALL
 
diff -Naur openssl-1.0.0q.orig/crypto/bio/b_print.c openssl-1.0.0q/crypto/bio/b_print.c
--- openssl-1.0.0q.orig/crypto/bio/b_print.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/b_print.c	2017-04-25 16:23:40.040526377 +0200
@@ -67,14 +67,18 @@
  * Stolen from tjh's ssl/ssl_trc.c stuff.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <ctype.h>
-#include <assert.h>
 #include <limits.h>
-#include "cryptlib.h"
+#include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #ifndef NO_SYS_TYPES_H
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #include <openssl/bn.h>         /* To get BN_LLONG properly defined */
 #include <openssl/bio.h>
@@ -84,6 +88,9 @@
 #  define HAVE_LONG_LONG 1
 # endif
 #endif
+#ifndef HAVE_LONG_LONG
+# define HAVE_LONG_LONG 0
+#endif
 
 /***************************************************************************/
 
@@ -125,14 +132,14 @@
 #define LLONG long
 #endif
 
-static void fmtstr     (char **, char **, size_t *, size_t *,
+static int fmtstr     (char **, char **, size_t *, size_t *,
 			const char *, int, int, int);
-static void fmtint     (char **, char **, size_t *, size_t *,
+static int fmtint     (char **, char **, size_t *, size_t *,
 			LLONG, int, int, int, int);
-static void fmtfp      (char **, char **, size_t *, size_t *,
+static int fmtfp      (char **, char **, size_t *, size_t *,
 			LDOUBLE, int, int, int);
-static void doapr_outch (char **, char **, size_t *, size_t *, int);
-static void _dopr(char **sbuffer, char **buffer,
+static int doapr_outch (char **, char **, size_t *, size_t *, int);
+static int _dopr(char **sbuffer, char **buffer,
 		  size_t *maxlen, size_t *retlen, int *truncated,
 		  const char *format, va_list args);
 
@@ -165,7 +172,7 @@
 #define char_to_int(p) (p - '0')
 #define OSSL_MAX(p,q) ((p >= q) ? p : q)
 
-static void
+static int
 _dopr(
     char **sbuffer,
     char **buffer,
@@ -200,7 +207,10 @@
             if (ch == '%')
                 state = DP_S_FLAGS;
             else
-                doapr_outch(sbuffer,buffer, &currlen, maxlen, ch);
+			{
+                if(!doapr_outch(sbuffer,buffer, &currlen, maxlen, ch))
+					return 0;
+			}
             ch = *format++;
             break;
         case DP_S_FLAGS:
@@ -231,7 +241,7 @@
             }
             break;
         case DP_S_MIN:
-            if (isdigit((unsigned char)ch)) {
+            if (op_isdigit((unsigned char)ch)) {
                 min = 10 * min + char_to_int(ch);
                 ch = *format++;
             } else if (ch == '*') {
@@ -249,7 +259,7 @@
                 state = DP_S_MOD;
             break;
         case DP_S_MAX:
-            if (isdigit((unsigned char)ch)) {
+            if (op_isdigit((unsigned char)ch)) {
                 if (max < 0)
                     max = 0;
                 max = 10 * max + char_to_int(ch);
@@ -306,8 +316,9 @@
                     value = va_arg(args, int);
                     break;
                 }
-                fmtint(sbuffer, buffer, &currlen, maxlen,
-                       value, 10, min, max, flags);
+                if (!fmtint(sbuffer, buffer, &currlen, maxlen,
+                       value, 10, min, max, flags))
+                    return 0;
                 break;
             case 'X':
                 flags |= DP_F_UP;
@@ -332,17 +343,19 @@
                         unsigned int);
                     break;
                 }
-                fmtint(sbuffer, buffer, &currlen, maxlen, value,
+                if (!fmtint(sbuffer, buffer, &currlen, maxlen, value,
                        ch == 'o' ? 8 : (ch == 'u' ? 10 : 16),
-                       min, max, flags);
+                       min, max, flags))
+                    return 0;
                 break;
             case 'f':
                 if (cflags == DP_C_LDOUBLE)
                     fvalue = va_arg(args, LDOUBLE);
                 else
                     fvalue = va_arg(args, double);
-                fmtfp(sbuffer, buffer, &currlen, maxlen,
-                      fvalue, min, max, flags);
+                if (!fmtfp(sbuffer, buffer, &currlen, maxlen,
+                      fvalue, min, max, flags))
+                    return 0;
                 break;
             case 'E':
                 flags |= DP_F_UP;
@@ -361,8 +374,9 @@
                     fvalue = va_arg(args, double);
                 break;
             case 'c':
-                doapr_outch(sbuffer, buffer, &currlen, maxlen,
-                    va_arg(args, int));
+                if(!doapr_outch(sbuffer, buffer, &currlen, maxlen,
+                    va_arg(args, int)))
+					return 0;
                 break;
             case 's':
                 strvalue = va_arg(args, char *);
@@ -372,13 +386,15 @@
 		    else
 			max = *maxlen;
 		}
-                fmtstr(sbuffer, buffer, &currlen, maxlen, strvalue,
-                       flags, min, max);
+                if (!fmtstr(sbuffer, buffer, &currlen, maxlen, strvalue,
+                       flags, min, max))
+                    return 0;
                 break;
             case 'p':
                 value = (long)va_arg(args, void *);
-                fmtint(sbuffer, buffer, &currlen, maxlen,
-                    value, 16, min, max, flags|DP_F_NUM);
+                if (!fmtint(sbuffer, buffer, &currlen, maxlen,
+                    value, 16, min, max, flags|DP_F_NUM))
+                    return 0;
                 break;
             case 'n': /* XXX */
                 if (cflags == DP_C_SHORT) {
@@ -400,7 +416,8 @@
                 }
                 break;
             case '%':
-                doapr_outch(sbuffer, buffer, &currlen, maxlen, ch);
+                if(!doapr_outch(sbuffer, buffer, &currlen, maxlen, ch))
+					return 0;
                 break;
             case 'w':
                 /* not supported yet, treat as next char */
@@ -424,12 +441,13 @@
     *truncated = (currlen > *maxlen - 1);
     if (*truncated)
         currlen = *maxlen - 1;
-    doapr_outch(sbuffer, buffer, &currlen, maxlen, '\0');
+    if(!doapr_outch(sbuffer, buffer, &currlen, maxlen, '\0'))
+		return 0;
     *retlen = currlen - 1;
-    return;
+    return 1;
 }
 
-static void
+static int
 fmtstr(
     char **sbuffer,
     char **buffer,
@@ -454,22 +472,27 @@
         padlen = -padlen;
 
     while ((padlen > 0) && (cnt < max)) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         --padlen;
         ++cnt;
     }
     while (*value && (cnt < max)) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, *value++);
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, *value++))
+			return 0;
         ++cnt;
     }
     while ((padlen < 0) && (cnt < max)) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         ++padlen;
         ++cnt;
     }
+
+	return 1;
 }
 
-static void
+static int
 fmtint(
     char **sbuffer,
     char **buffer,
@@ -484,7 +507,7 @@
     int signvalue = 0;
     const char *prefix = "";
     unsigned LLONG uvalue;
-    char convert[DECIMAL_SIZE(value)+3];
+    char convert[DECIMAL_SIZE(value)+3]; /* ARRAY OK 2009-05-25 yngve */
     int place = 0;
     int spadlen = 0;
     int zpadlen = 0;
@@ -519,7 +542,7 @@
     convert[place] = 0;
 
     zpadlen = max - place;
-    spadlen = min - OSSL_MAX(max, place) - (signvalue ? 1 : 0) - strlen(prefix);
+    spadlen = min - OSSL_MAX(max, place) - (signvalue ? 1 : 0) - op_strlen(prefix);
     if (zpadlen < 0)
         zpadlen = 0;
     if (spadlen < 0)
@@ -533,37 +556,45 @@
 
     /* spaces */
     while (spadlen > 0) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         --spadlen;
     }
 
     /* sign */
     if (signvalue)
-        doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue);
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue))
+			return 0;
 
     /* prefix */
     while (*prefix) {
-	doapr_outch(sbuffer, buffer, currlen, maxlen, *prefix);
+	if(!doapr_outch(sbuffer, buffer, currlen, maxlen, *prefix))
+		return 0;
 	prefix++;
     }
 
     /* zeros */
     if (zpadlen > 0) {
         while (zpadlen > 0) {
-            doapr_outch(sbuffer, buffer, currlen, maxlen, '0');
+            if(!doapr_outch(sbuffer, buffer, currlen, maxlen, '0'))
+				return 0;
             --zpadlen;
         }
     }
     /* digits */
     while (place > 0)
-        doapr_outch(sbuffer, buffer, currlen, maxlen, convert[--place]);
+	{
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, convert[--place]))
+			return 0;
+	}
 
     /* left justified spaces */
     while (spadlen < 0) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         ++spadlen;
     }
-    return;
+    return 1;
 }
 
 static LDOUBLE
@@ -576,7 +607,7 @@
 }
 
 static LDOUBLE
-pow_10(int in_exp)
+op_pow_10(int in_exp)
 {
     LDOUBLE result = 1;
     while (in_exp) {
@@ -597,7 +628,7 @@
     return intpart;
 }
 
-static void
+static int
 fmtfp(
     char **sbuffer,
     char **buffer,
@@ -610,8 +641,8 @@
 {
     int signvalue = 0;
     LDOUBLE ufvalue;
-    char iconvert[20];
-    char fconvert[20];
+    char iconvert[20]; /* ARRAY OK 2009-05-25 yngve */
+    char fconvert[20]; /* ARRAY OK 2009-05-25 yngve */
     int iplace = 0;
     int fplace = 0;
     int padlen = 0;
@@ -640,8 +671,8 @@
 
     /* we "cheat" by converting the fractional part to integer by
        multiplying by a factor of 10 */
-    max10 = roundv(pow_10(max));
-    fracpart = roundv(pow_10(max) * (ufvalue - intpart));
+    max10 = roundv(op_pow_10(max));
+    fracpart = roundv(op_pow_10(max) * (ufvalue - intpart));
 
     if (fracpart >= max10) {
         intpart++;
@@ -682,47 +713,60 @@
 
     if ((flags & DP_F_ZERO) && (padlen > 0)) {
         if (signvalue) {
-            doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue);
+            if(!doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue))
+				return 0;
             --padlen;
             signvalue = 0;
         }
         while (padlen > 0) {
-            doapr_outch(sbuffer, buffer, currlen, maxlen, '0');
+            if(!doapr_outch(sbuffer, buffer, currlen, maxlen, '0'))
+				return 0;
             --padlen;
         }
     }
     while (padlen > 0) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         --padlen;
     }
     if (signvalue)
-        doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue);
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, signvalue))
+			return 0;
 
     while (iplace > 0)
-        doapr_outch(sbuffer, buffer, currlen, maxlen, iconvert[--iplace]);
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, iconvert[--iplace]))
+			return 0;
 
     /*
      * Decimal point. This should probably use locale to find the correct
      * char to print out.
      */
     if (max > 0 || (flags & DP_F_NUM)) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, '.');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, '.'))
+			return 0;
 
         while (fplace > 0)
-            doapr_outch(sbuffer, buffer, currlen, maxlen, fconvert[--fplace]);
+		{
+            if(!doapr_outch(sbuffer, buffer, currlen, maxlen, fconvert[--fplace]))
+				return 0;
+		}
     }
     while (zpadlen > 0) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, '0');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, '0'))
+			return 0;
         --zpadlen;
     }
 
     while (padlen < 0) {
-        doapr_outch(sbuffer, buffer, currlen, maxlen, ' ');
+        if(!doapr_outch(sbuffer, buffer, currlen, maxlen, ' '))
+			return 0;
         ++padlen;
     }
+
+	return 1;
 }
 
-static void
+static int
 doapr_outch(
     char **sbuffer,
     char **buffer,
@@ -730,37 +774,43 @@
     size_t *maxlen,
     int c)
 {
-    /* If we haven't at least one buffer, someone has doe a big booboo */
+	char *temp;
+    /* If we haven't at least one buffer, someone has done a big booboo */
     assert(*sbuffer != NULL || buffer != NULL);
 
     if (buffer) {
-	while (*currlen >= *maxlen) {
-	    if (*buffer == NULL) {
-		if (*maxlen == 0)
-		    *maxlen = 1024;
-		*buffer = OPENSSL_malloc(*maxlen);
-		if (*currlen > 0) {
-		    assert(*sbuffer != NULL);
-		    memcpy(*buffer, *sbuffer, *currlen);
+		while (*currlen >= *maxlen) {
+			if (*buffer == NULL) {
+				if (*maxlen == 0)
+					*maxlen = 1024;
+				*buffer = (char *) OPENSSL_malloc(*maxlen);
+				if(!*buffer)
+					return 0;
+				if (*currlen > 0) {
+					assert(*sbuffer != NULL);
+					op_memcpy(*buffer, *sbuffer, *currlen);
+				}
+				*sbuffer = NULL;
+			} else {
+				*maxlen += 1024;
+				temp = (char *) OPENSSL_realloc(*buffer, *maxlen);
+				if(temp == NULL)
+					return 0;
+				*buffer = temp;
+			}
 		}
-		*sbuffer = NULL;
-	    } else {
-		*maxlen += 1024;
-		*buffer = OPENSSL_realloc(*buffer, *maxlen);
-	    }
-	}
-	/* What to do if *buffer is NULL? */
-	assert(*sbuffer != NULL || *buffer != NULL);
+		/* What to do if *buffer is NULL? */
+		assert(*sbuffer != NULL || *buffer != NULL);
     }
 
     if (*currlen < *maxlen) {
-	if (*sbuffer)
-	    (*sbuffer)[(*currlen)++] = (char)c;
-	else
-	    (*buffer)[(*currlen)++] = (char)c;
+		if (*sbuffer)
+			(*sbuffer)[(*currlen)++] = (char)c;
+		else
+			(*buffer)[(*currlen)++] = (char)c;
     }
 
-    return;
+	return 1;
 }
 
 /***************************************************************************/
@@ -781,14 +831,15 @@
 int BIO_vprintf (BIO *bio, const char *format, va_list args)
 	{
 	int ret;
-	size_t retlen;
-	char hugebuf[1024*2];	/* Was previously 10k, which is unreasonable
+	size_t retlen=0;
+	/* char hugebuf[1024*2];	*/ /* ARRAY OK DISABLED 2009-08-07 alexeik */
+				/* Was previously 10k, which is unreasonable
 				   in small-stack environments, like threads
 				   or DOS programs. */
-	char *hugebufp = hugebuf;
-	size_t hugebufsize = sizeof(hugebuf);
+	char *hugebufp = NULL; /* hugebuf; */ /* Disabled stack buffer, demand allocated buffer */
+	size_t hugebufsize = 0; /* sizeof(hugebuf); */
 	char *dynbuf = NULL;
-	int ignored;
+	int ignored=0;
 
 	dynbuf = NULL;
 	CRYPTO_push_info("doapr()");
@@ -801,7 +852,7 @@
 		}
 	else
 		{
-		ret=BIO_write(bio, hugebuf, (int)retlen);
+		ret= 0; /* BIO_write(bio, hugebuf, (int)retlen);*/ /* Disabled */
 		}
 	CRYPTO_pop_info();
 	return(ret);
diff -Naur openssl-1.0.0q.orig/crypto/bio/b_sock.c openssl-1.0.0q/crypto/bio/b_sock.c
--- openssl-1.0.0q.orig/crypto/bio/b_sock.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/b_sock.c	2017-04-25 16:23:40.041526224 +0200
@@ -56,9 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #define USE_SOCKETS
 #include "cryptlib.h"
 #include <openssl/bio.h>
@@ -182,7 +187,7 @@
 		BIOerr(BIO_F_BIO_GET_PORT,BIO_R_NO_PORT_DEFINED);
 		return(0);
 		}
-	i=atoi(str);
+	i=op_atoi(str);
 	if (i != 0)
 		*port_ptr=(unsigned short)i;
 	else
@@ -201,22 +206,22 @@
 		CRYPTO_w_unlock(CRYPTO_LOCK_GETSERVBYNAME);
 		if(s == NULL)
 			{
-			if (strcmp(str,"http") == 0)
+			if (op_strcmp(str,"http") == 0)
 				*port_ptr=80;
-			else if (strcmp(str,"telnet") == 0)
+			else if (op_strcmp(str,"telnet") == 0)
 				*port_ptr=23;
-			else if (strcmp(str,"socks") == 0)
+			else if (op_strcmp(str,"socks") == 0)
 				*port_ptr=1080;
-			else if (strcmp(str,"https") == 0)
+			else if (op_strcmp(str,"https") == 0)
 				*port_ptr=443;
-			else if (strcmp(str,"ssl") == 0)
+			else if (op_strcmp(str,"ssl") == 0)
 				*port_ptr=443;
-			else if (strcmp(str,"ftp") == 0)
+			else if (op_strcmp(str,"ftp") == 0)
 				*port_ptr=21;
-			else if (strcmp(str,"gopher") == 0)
+			else if (op_strcmp(str,"gopher") == 0)
 				*port_ptr=70;
 #if 0
-			else if (strcmp(str,"wais") == 0)
+			else if (op_strcmp(str,"wais") == 0)
 				*port_ptr=21;
 #endif
 			else
@@ -301,7 +306,7 @@
 	MemCheck_off();
 	ret=(struct hostent *)OPENSSL_malloc(sizeof(struct hostent));
 	if (ret == NULL) return(NULL);
-	memset(ret,0,sizeof(struct hostent));
+	op_memset(ret,0,sizeof(struct hostent));
 
 	for (i=0; a->h_aliases[i] != NULL; i++)
 		;
@@ -309,7 +314,7 @@
 	ret->h_aliases = (char **)OPENSSL_malloc(i*sizeof(char *));
 	if (ret->h_aliases == NULL)
 		goto err;
-	memset(ret->h_aliases, 0, i*sizeof(char *));
+	op_memset(ret->h_aliases, 0, i*sizeof(char *));
 
 	for (i=0; a->h_addr_list[i] != NULL; i++)
 		;
@@ -317,16 +322,16 @@
 	ret->h_addr_list=(char **)OPENSSL_malloc(i*sizeof(char *));
 	if (ret->h_addr_list == NULL)
 		goto err;
-	memset(ret->h_addr_list, 0, i*sizeof(char *));
+	op_memset(ret->h_addr_list, 0, i*sizeof(char *));
 
-	j=strlen(a->h_name)+1;
+	j=op_strlen(a->h_name)+1;
 	if ((ret->h_name=OPENSSL_malloc(j)) == NULL) goto err;
-	memcpy((char *)ret->h_name,a->h_name,j);
+	op_memcpy((char *)ret->h_name,a->h_name,j);
 	for (i=0; a->h_aliases[i] != NULL; i++)
 		{
-		j=strlen(a->h_aliases[i])+1;
+		j=op_strlen(a->h_aliases[i])+1;
 		if ((ret->h_aliases[i]=OPENSSL_malloc(j)) == NULL) goto err;
-		memcpy(ret->h_aliases[i],a->h_aliases[i],j);
+		op_memcpy(ret->h_aliases[i],a->h_aliases[i],j);
 		}
 	ret->h_length=a->h_length;
 	ret->h_addrtype=a->h_addrtype;
@@ -334,7 +339,7 @@
 		{
 		if ((ret->h_addr_list[i]=OPENSSL_malloc(a->h_length)) == NULL)
 			goto err;
-		memcpy(ret->h_addr_list[i],a->h_addr_list[i],a->h_length);
+		op_memcpy(ret->h_addr_list[i],a->h_addr_list[i],a->h_length);
 		}
 	if (0)
 		{
@@ -395,7 +400,7 @@
 	 */
 	CRYPTO_w_lock(CRYPTO_LOCK_GETHOSTBYNAME);
 #  endif
-	j=strlen(name);
+	j=op_strlen(name);
 	if (j < 128)
 		{
 		for (i=0; i<GHBN_NUM; i++)
@@ -407,7 +412,7 @@
 				}
 			if (ghbn_cache[i].order > 0)
 				{
-				if (strncmp(name,ghbn_cache[i].name,128) == 0)
+				if (op_strncmp(name,ghbn_cache[i].name,128) == 0)
 					break;
 				}
 			}
@@ -450,7 +455,7 @@
 			BIOerr(BIO_F_BIO_GETHOSTBYNAME,ERR_R_MALLOC_FAILURE);
 			goto end;
 			}
-		strncpy(ghbn_cache[lowi].name,name,128);
+		op_strncpy(ghbn_cache[lowi].name,name,128);
 		ghbn_cache[lowi].order=BIO_ghbn_miss+BIO_ghbn_hits;
 		}
 	else
diff -Naur openssl-1.0.0q.orig/crypto/bio/bf_buff.c openssl-1.0.0q/crypto/bio/bf_buff.c
--- openssl-1.0.0q.orig/crypto/bio/bf_buff.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bf_buff.c	2017-04-25 16:23:40.042525793 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 
 static int buffer_write(BIO *h, const char *buf,int num);
@@ -146,7 +148,7 @@
 	if (i != 0)
 		{
 		if (i > outl) i=outl;
-		memcpy(out,&(ctx->ibuf[ctx->ibuf_off]),i);
+		op_memcpy(out,&(ctx->ibuf[ctx->ibuf_off]),i);
 		ctx->ibuf_off+=i;
 		ctx->ibuf_len-=i;
 		num+=i;
@@ -318,14 +320,14 @@
 	case BIO_C_SET_BUFF_READ_DATA:
 		if (num > ctx->ibuf_size)
 			{
-			p1=OPENSSL_malloc((int)num);
+			p1=(char*)OPENSSL_malloc((int)num);
 			if (p1 == NULL) goto malloc_error;
 			if (ctx->ibuf != NULL) OPENSSL_free(ctx->ibuf);
 			ctx->ibuf=p1;
 			}
 		ctx->ibuf_off=0;
 		ctx->ibuf_len=(int)num;
-		memcpy(ctx->ibuf,ptr,(int)num);
+		op_memcpy(ctx->ibuf,ptr,(int)num);
 		ret=1;
 		break;
 	case BIO_C_SET_BUFF_SIZE:
@@ -507,6 +509,6 @@
 
 static int buffer_puts(BIO *b, const char *str)
 	{
-	return(buffer_write(b,str,strlen(str)));
+	return(buffer_write(b,str,op_strlen(str)));
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/bio/bf_lbuf.c openssl-1.0.0q/crypto/bio/bf_lbuf.c
--- openssl-1.0.0q.orig/crypto/bio/bf_lbuf.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bf_lbuf.c	2017-04-25 16:23:40.043526758 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bio.h>
 #include <openssl/evp.h>
@@ -182,7 +184,7 @@
 				{
 				if (i >= p - in)
 					{
-					memcpy(&(ctx->obuf[ctx->obuf_len]),
+					op_memcpy(&(ctx->obuf[ctx->obuf_len]),
 						in,p - in);
 					ctx->obuf_len += p - in;
 					inl -= p - in;
@@ -191,7 +193,7 @@
 					}
 				else
 					{
-					memcpy(&(ctx->obuf[ctx->obuf_len]),
+					op_memcpy(&(ctx->obuf[ctx->obuf_len]),
 						in,i);
 					ctx->obuf_len += i;
 					inl -= i;
@@ -220,7 +222,7 @@
 BIO_write(b->next_bio, ">*>", 3);
 #endif
 			if (i < ctx->obuf_len)
-				memmove(ctx->obuf, ctx->obuf + i,
+				op_memmove(ctx->obuf, ctx->obuf + i,
 					ctx->obuf_len - i);
 			ctx->obuf_len-=i;
 			}
@@ -256,7 +258,7 @@
 	   saved for the next trip. */
 	if (inl > 0)
 		{
-		memcpy(&(ctx->obuf[ctx->obuf_len]), in, inl);
+		op_memcpy(&(ctx->obuf[ctx->obuf_len]), in, inl);
 		ctx->obuf_len += inl;
 		num += inl;
 		}
@@ -307,7 +309,7 @@
 				{
 				ctx->obuf_len = obs;
 				}
-			memcpy(p, ctx->obuf, ctx->obuf_len);
+			op_memcpy(p, ctx->obuf, ctx->obuf_len);
 			OPENSSL_free(ctx->obuf);
 			ctx->obuf=p;
 			ctx->obuf_size=obs;
@@ -341,7 +343,7 @@
 				BIO_copy_next_retry(b);
 				if (r <= 0) return((long)r);
 				if (r < ctx->obuf_len)
-					memmove(ctx->obuf, ctx->obuf + r,
+					op_memmove(ctx->obuf, ctx->obuf + r,
 						ctx->obuf_len - r);
 				ctx->obuf_len-=r;
 				}
diff -Naur openssl-1.0.0q.orig/crypto/bio/bf_nbio.c openssl-1.0.0q/crypto/bio/bf_nbio.c
--- openssl-1.0.0q.orig/crypto/bio/bf_nbio.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bf_nbio.c	2017-04-25 16:23:40.044528002 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #include <openssl/bio.h>
diff -Naur openssl-1.0.0q.orig/crypto/bio/bf_null.c openssl-1.0.0q/crypto/bio/bf_null.c
--- openssl-1.0.0q.orig/crypto/bio/bf_null.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bf_null.c	2017-04-25 16:23:40.045526733 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bio.h>
 
